;-----------------------------;
; ASSM_MX/4K - SP_580 RAMFOS  ;
;-----------------------------;
; p p p________________________
;  E9AD LXI  H,0009;  p  EDIT
;  E9B0 PUSH H
;  E9B1 CALL EA54
;  E9B4 LHLD 1087  ; p  pp p
;  E9B7 XCHG
;  E9B8 LXI  H,F000; p    p
;  E9BB STA  FFFE
;  E9BE RET;         JMP  0009  ROM

;  0009 JMP  0017;   pp ROM __________________

;  0012 CALL 0051
;  0015 POP  H
;  0016 RET

;  0017 PUSH H; F000 p    p
;  0018 XCHG; [DE] - p ; [HL]- pp
;  0019 PUSH H;    - p  pp p
;  001A LXI  H,1800
;  001D JMP  0012

;  0051 LXI  B,07FF
;  0054 MOV  A,M
;  0055 STAX D;    - p ;
;  0056 MOV  A,B
;  0057 ORA  C
;  0058 RZ;        - p  pp p
;  0059 INX  H
;  005A INX  D
;  005B DCX  B
;  005C JMP  0054

        ORG  0100H;- 0F000H; - 

        STA  ZAK;  p  ROM - p 
        INX  H;
        SHLD BHL
STR:
        LXI  H,ASS; "ASSM_MX/4K:..."
        CALL LNS

        LHLD BHL
        MOV  M,A;   A = 0
        STA  SOR;   ORG  

        MOV  H,A
        MOV  L,A
        SHLD AOR;  ORG

        INR  A;     A = 1
        STA  K17;  [1053]

        CALL KBD;  p 
        CPI  1FH;  STR - pp ?
        JZ   EXIT; 

        STA  KEY;  p.  
        CPI  03H;  F4 -   
        JP   STR;  p  

        DCR  A;    02H = F3: 02H-1=01H  - Z
        JNZ  ASM;  F3 - EXE

        DCR  A;    01H - 1 = 00H
        STA  NER
        CALL FIL;  p  LIN
;                  HL -   ,
;                  DE -   .
        XCHG;      HL <-> DE -   
        SHLD ELN;  HL -   
        LHLD BHL
        DCX  H
        CALL CMHLDE
        JNZ  K52

        LXI  H,ASS; "ASSM_MX/4K:..."
        CALL LNS
ASM:
        LXI  H,BUF;  1100H p  pp
        SHLD BBF;       pp

        LXI  H,BEG;  0000H p p 
        SHLD FIN;      p 

        XRA  A;     A = 0
        STA  NER;    
NXT:
        XRA  A;     A = 0
        STA  ERR;    
        STA  BA2

        LHLD FIN;     p 
        SHLD BFN;     p 

        LXI  SP,STK;
        CALL GAN;     p
;                    p  p p  0DH
        LXI  H,SBF; 1066H = p p 128 
        MOV  A,M
        CPI  3BH;   ';' p ?
        JZ   TBFRET

        CALL TO_CMD;

        CPI  3AH;   ':'
        JNZ  K45

        XRA  A;  p 
        CMP  C;    ?
        JZ   ITSERR; 

        PUSH H
        LDA  KEY
        DCR  A
        CZ   ITEQU; EQU ?
        CALL ITMET
        POP  H

        CALL MIMO20
        ORA  A
        JZ   TBFRET

        CPI  3BH;   ';'
        JZ   TBFRET
        CALL TO_CMD
K45:
        PUSH H
        CALL ANACOD
        POP  H

        CALL ANLARG;

        PUSH H
        LXI  H,TB0;   TB0
        LDA  OFS
        MOV  E,A
        MVI  D,00H; DE = 00.OFS
        DAD  D
        DAD  D;     HL = TB0+OFS*2

        MOV  E,M
        INX  H
        MOV  A,M
        CMP  C;     -1    
        JNZ  ERRN08

        LXI  H,TBFUNK
        DAD  D;   HL=TBFUNK+DE
        LXI  D,TBFRET
        XCHG;     HL=TBFRET; DE=TBFUNK+DE
        XTHL;    [SP]=HL=TBFRET;
        PUSH D;  [SP+1]=TBFUNK+DE
        LDA  NUM8REG
        RET;  -  JMP TBFUNK+DE
;-----------------------------------------
ITSERR:
        MVI  B,10H;  00010000b
CODERR:
        CALL NERCOD;   
TBFRET:;___________    p   
        CALL DISPER;

        LXI  H,MAX;  pp  
        XCHG
        LHLD FIN
        CALL ENDOZY

        CALL KLA
        CPI  1FH;    STR
        JNZ  NXT;     . p
        JMP  EXIT;   
;---------------------
ITEQU:
        CALL MIMO20
        MOV  A,M
        CPI  45H; 'E'
        RNZ
        INX  H
        MOV  A,M
        CPI  51H; 'Q'
        RNZ
        STA  BA2; 'Q'-EQU
        RET

TBFUNK:
;_______ _____
        ORI  40H; 0100.0000b 0,1
        STA  KOP;            2,3,4
        CALL K7B;            5,6,7
TBF008:
        LDA  NUM_REG;        8,9,A
TBF00B:
        JMP  KOPREG;         B,C,D
TBF00E:
        ORI  06H; 0000.0110b E,F
        STA  KOP;            10
        CALL K7B;            13
TBF016:
        MVI  C,01H;          16
        JMP  KODMEM;         18
TBF01B:
        CALL K5A;            1B
        ORI  01H; 0000.0001b 1E
        STA  KOP;            20
        CALL K7B;            23
TBF026:
        MVI  C,02H;          26
        JMP  KODMEM;         28
TBF02B:
        CALL K5A;            2B
TBF02E:
        JMP  KOPREG;         2E
TBF031:
        CALL K5C;            31
        JMP  KOPREG;         34
TBF037:
        CALL K5E;            37
        JMP  KOPREG;         3A
TBF03D:
        LDA  NUM_REG;[105AH] 3D
        MOV  B,A;            40
        ANI  07H; 0000.0111b 41
        CMP  B;              43
        JNZ  ERRN08;   pp 44

        RLC; * 2             47
        RLC; * 4             48
        RLC; * 8             49
        JMP  KOPREG;         4A
TBF04D:
        LHLD FIN;            4D
        XCHG;                50
        LHLD NUM_REG;        51
        DAD  D;              54
        SHLD FIN;            55
        RET;                 58

;----------------------------------
TBF059:
        LXI  H,SBF; p p 59
        CALL TO_CMD;             5C
        CPI  3AH;   ':'          5F
        JNZ  ITSERR;             61

        LHLD NUM_REG;            64
        SHLD BFN;                67
        XCHG;                    6A

        LDA  K17;                6B
        DCR  A;                  6E
        RNZ;                     6F

        LDA  ERR;                70
        DCR  A;                  73
        RZ;                      74
        JM   K50;                75
;----------------------------------
        LXI  D,0FFFEH; ROM       78
K4B:
        LHLD K1F; [105DH]        7B
        MOV  M,E;                7E
        INX  H;                  7F
        MOV  M,D;                80
        RET;                     81
TBF082:
        XCHG;                    82
        LHLD FIN
        LDAX D
        CPI  27H; [']
        JNZ  K4E
        INX  D;                  8C
K4D:
        LDAX D;    ''
        INX  D
        ORA  A;   A = 0 ?
        JZ   ERRN08;             90
        CPI  27H; [']
        JZ   K4F
        MOV  M,A;  -  
        INX  H
        JMP  K4D
K4E:
        LDA  NUM_REG;            9D
        MOV  M,A;                A0
        INX  H
        LDA  OFS
        CPI  0EH
        JZ   K4F

        LDA  NUM8REG
        MOV  M,A
        INX  H
K4F:
        SHLD FIN;                AF
        XCHG;
        CALL MIMO20
        ORA  A;   A = 0 ?
        RZ
        CPI  3BH; ';'
        RZ
        CALL K7B
        JMP  TBF082;             BE
;---------------------------------- ORG
TBF0C1:
        LDA  SOR;                C1
        ORA  A
        RNZ
        INR  A
        STA  SOR

        LHLD NUM_REG; ORG
        SHLD AOR;  ORG
        RET;                     D0
K50:
        LDA  BA2
        ORA  A
        RNZ
        JMP  K4B;
;F1CC:  D6,  D7,D8
;       C3   71 F1 = POP PSW
;----------------------------------
ASMEND:
        CALL DISPER
        LXI  H,K17
        DCR  M
        JZ   ASM

        LHLD FIN;
        DCX  H;   HL -  
        XCHG;     DE = HL = FIN
        LHLD AOR;  ORG
        DAD  D
        CALL PSSCR
K52:
        MVI  C,2FH; '/'
        CALL HLHEXC;    
        XCHG
        CALL HLHEXC;      

        LXI  H,ERS; ':'
        CALL LNS

        LDA  NER
        CALL HEK;    
        ORA  A
        JNZ  STR

        LXI  H,LIN; pp
        CALL EXT
        LHLD ELN;   p 
        XCHG
        LHLD BHL;   p 
        DCX  H
        CALL SAV;   p 

        LXI  H,EXE; pp
        CALL EXT
        LHLD FIN;   p 
        DCX  H
        XCHG
        LXI  H,BEG; p 
        CALL SAV;   p 
EXIT:
        LHLD BHL
        DCX  H
        JMP  EDT;   0E806H - EDIT
;----------------------------------
PSSCR:
        MVI  A,0AH; p p
        CALL SCA;     'A'
        RNZ

        LXI  B,0320H; 4 p
LOOP3:
        DCR  B
        RM
        CALL SCR;       'C'
        JMP  LOOP3
;----------------------------------
KOPREG:
        MOV  B,A
        LDA  KOP
        ORA  B
        LHLD FIN
KOPMEM:
        MOV  M,A
        INX  H
INXMEM:
        SHLD FIN
        RET
KODMEM:;_____________ C- 
        LHLD NUM_REG
        XCHG;         DE = NUM_REG
        LHLD FIN
        LDA  KOP
        MOV  M,A
        INX  H
        MOV  M,E
        INX  H
        DCR  C
        JZ   INXMEM
        MOV  A,D
        JMP  KOPMEM
K5A:
        CPI  40H; '@'
K5B:
        JNZ  K5D
        MVI  A,30H; '0'
        RET
K5C:
        CPI  48H; 'H'
        JMP  K5B
K5D:
        CPI  20H; ' '
        RZ
K5E:
        CPI  10H; ''
        RZ

        ORA  A
        JNZ  ERRN08
        RET
;----------------------------------
DUBMET:
        MVI  B,01H;    00000001b
        JMP  NERCOD;   -  
BADMET:
        MVI  B,02H;    00000010b
        LXI  D,0FFFEH; -   
NERCOD:
        PUSH H
        LXI  H,ERR
        MOV  A,M
        ORA  B
        MOV  M,A

        LXI  H,NER
        MOV  A,M
        INR  A
        DAA
        MOV  M,A
        POP  H
        RET
ERRN08:
        MVI  B,08H
        JMP  CODERR
;___________________p  p 
GAN:
        LXI  D,SBF; p p
        MVI  C,7FH;  p 127 
        LHLD BBF;    p   pp
ANL:
        MOV  A,M;      pp
        INX  H;       
        CPI  0FFH; '.' ?
        JZ   ASMEND

        CPI  0DH;  '' ?
        JZ   BKK

        CPI  09H;  'Tab' ?
        JNZ  PSK
;----------------- 3 p --- Tab -----------------
        MVI  A,20H; p
        PUSH H;----> p   pp
        MVI  H,03H;  p
TAB:
        STAX D; p ->  p p
        INX  D;     p p
        DCR  C;  p - 1
        DCR  H;  p - 1
        JNZ  TAB
        POP  H;<---- p   pp
;---------------------------------------------------
PSK:
        CPI  0AH; '' ?
        JZ   ANL; p  p
;                 '' pp
        STAX D;     ->  p p
        DCR  C;    p - 1
        JM   ANL; p  p
        INX  D;       p p
        JMP  ANL; p  p
;---------------------------------------------------
BKK:
        XRA  A;   A = 0 -
        STAX D;   0 ->  p p
        MOV  A,C;  p
        CPI  7FH; 127 ?
        JZ   ANL; p  p
        SHLD BBF;  p  pp
        RET
;---------------------------------------------------
TO_CMD:
        MVI  C,06H;  p
        LXI  D,CMD;  
        PUSH D;----> p  
        MVI  A,20H; p
CLRCMD:
        STAX D;  -  p  . 
        INX  D
        DCR  C;      .-1
        JNZ  CLRCMD

        POP  D;<---- p  
        CALL MIMO20; p p
;              [HL]->A  p
TSTLAT:
        CPI  3FH;    '?'
        RM;           ?
        CPI  80H
        RP;          'A'=p. 
PUTCMD:
        MOV  B,A;    p..
        MOV  A,C;     .
        CPI  06H;     6 ?
        JZ   NXTSYM

        MOV  A,B;    ..
        STAX D;   ->  p  
        INX  D
        INR  C
NXTSYM:
        INX  H
        MOV  A,M;    ..p p
        CPI  30H;    '0'
        JM   MIMO20; p p

        CPI  3AH;    ':' ?
        INX  H
        RZ
        DCX  H
        JM   PUTCMD
        JMP  TSTLAT

MIMO20:
        MOV  A,M;      pp
        CPI  20H;    p ?
        RNZ
        INX  H;     p p
        JMP  MIMO20
;----------------------
ITMET:
        CALL CMPMET

        LDA  K17
        DCR  A
        JNZ  K75

        CMP  C
        JNZ  K6F

        LDA  KEY
        DCR  A
        JZ   K72

        MVI  A,0FFH
        MOV  M,A
        INX  H
        MOV  M,A
        RET
;----------------------
K6F:
        LXI  D,CMD
        MVI  C,06H
LOOP70:
        LDAX D
        MOV  M,A
        INX  D
        INX  H
        DCR  C
        JNZ  LOOP70

        CALL PUTOFS
        INX  H
        XRA  A
        STA  BA2

        MOV  M,A
        SHLD ELN
        XCHG
        CALL HIM
        XCHG
ENDOZY:
        CALL CMHLDE
        RC
        LXI  H,OZY; '  '
        CALL LNS
        JMP  STR
;------------------------------
K72:
        LDA  BA2
        ORA  A
        RNZ
PUTOFS:
        SHLD K1F

        PUSH H
        LHLD FIN
        XCHG;     DE = FIN
        LHLD AOR;  ORG
        DAD  D;   HL = OFFSET
        XCHG;     DE = OFFSET

        POP  H;   PUT OFFSET
        MOV  M,E
        INX  H
        MOV  M,D
        RET

CMHLDE:
        MOV  A,H
        CMP  D
        RNZ
        MOV  A,L
        CMP  E
        RET

K75:
        MOV  C,M
        INX  H
        MOV  B,M
        CMP  B
        RNZ
        CMP  C
        JZ   DUBMET

        DCR  A
        CMP  C
        JZ   BADMET
        RET
;----------------------
GETMET:
        CALL CMPMET
        JM   BADMET
        MOV  E,M; p  
        INX  H;    
        MOV  D,M; p 
        RET
;----------------------
CMPMET:
        LHLD BHL
K78:
        MVI  C,06H
        MOV  A,M
        DCR  A
        RM

        PUSH H
        LXI  D,CMD
LOOP79:
        LDAX D
        CMP  M
        JZ   K7A
        POP  H
        LXI  B,0008H
        DAD  B
        JMP  K78
K7A:
        INX  D
        INX  H
        DCR  C
        JNZ  LOOP79
        POP  D
        RET
;----------------------
K7B:
        MOV  A,M
        CPI  2CH; ','
        JNZ  ERRN08
        INX  H
        CALL ANLARG
        LDA  OFS
        CPI  03H
        JZ   K7C
        DCR  C
K7C:
        DCR  C
        JNZ  ERRN08
        RET

ANLARG:
        CALL TO_CMD
        XRA  A
        STA  ZNK
        STA  NUM_REG
        STA  NUM8REG
        CMP  C
        JZ   K7F
        CALL ANAREG
        CPI  01H;  pp
        JNZ  K7E
        MOV  C,A
        CALL K84
        RZ
        JC   ERRN08
K7E:
        PUSH H
        CALL GETMET
        JMP  K83
K7F:
        CALL K84
        RZ
        CPI  2BH; '+'
        JZ   K80
        CPI  2DH; '-'
        JNZ  K81
K80:
        STA  ZNK
        INX  H
K81:
        CALL K8A
        INR  C
        JZ   ERRN08
        LDA  ZNK
        CPI  2DH; '-'
        JNZ  K82
        XRA  A
        SUB  E
        MOV  E,A
        MVI  A,00H
        SBB  D
        MOV  D,A
K82:
        PUSH H
K83:
        LHLD NUM_REG
        DAD  D
        SHLD NUM_REG
        POP  H

        CALL K8A
        INR  C
        JNZ  ERRN08
        MVI  C,02H
        JMP  K7F
K84:
        MOV  A,M
        ORA  A;   A = 0 ?
        RZ
        CPI  2CH; ','
        RZ
        CPI  3BH; '?'
        RZ
        STC
        RET
ANAREG:
        PUSH H
        LXI  H,TB1; pp A,B,C,D,E,F,SP,PSW
        MOV  B,C
K86:
        LXI  D,CMD; 1-  
        MOV  C,B
        MOV  A,M; <-TB1 -  
        INX  H; -->  pp
        ORA  A
        JZ   STBYTE; A=0 -   
        CMP  C
        JZ   K88; C = A   
        MOV  C,A
HLUPC:
        INX  H;    TB1
        DCR  C; <-TB1+1 C p
        JNZ  HLUPC;    
        INX  H; -->  pp
        JMP  K86;  pp 
K88:
        LDAX D; 1-  
        INX  D; 2-  
        CMP  M; 1-   =  pp ?
        JNZ  HLUPC;    TB1
        INX  H; = R
        DCR  C
        JNZ  K88

        MOV  A,M; A = R
        STA  NUM_REG
        RLC; * 2
        RLC; * 4
        RLC; * 8
        STA  NUM8REG
        MVI  A,01H;  pp
;                    -  
STBYTE:
        POP  H
        RET
K8A:
        CALL TO_CMD
        DCR  C
        JP   K95
        MOV  A,M
        CPI  27H; [']
        JZ   K92

        CPI  24H; '$'
        JZ   K96

        CPI  30H; '0'
        RM
        CPI  3AH; ':'
        RP
        LXI  D,CMD
        MVI  C,00H
K8B:
        SUI  30H
        STAX D
        INX  D
        INX  H
        MOV  A,M
        CPI  30H; '0'
        JM   K8C
        CPI  3AH; ':'
        JM   K8B
        CPI  41H; 'A'
        JM   K8C
        INR  C
        CPI  48H; 'H'
        JZ   DOHEX
        CPI  4AH; 'J'
        JP   ERRN08
        SUI  07H
        JMP  K8B
K8C:
        XRA  A
        CMP  C
        JNZ  ERRN08
        MVI  A,19H; ''
        JMP  K8E
DOHEX:
        INX  H
        MVI  A,29H; ')'
K8E:
        STAX D
        PUSH H
        LXI  H,CMD
        LXI  D,BEG
        SBI  19H
K8F:
        MOV  B,A
        MOV  A,M
        INX  H
        CPI  10H; A=10H?
        JP   K97
        MOV  C,A
        MOV  A,B
        ORA  A
        MVI  B,00H
        PUSH H
        MOV  H,D
        MOV  L,E
        DAD  H
        DAD  H
        JNZ  K90
        DAD  D
        JMP  K91
K90:
        DAD  H
K91:
        DAD  H
        DAD  B
        XCHG
        POP  H
        JMP  K8F
K92:
        MVI  C,02H
        LDA  OFS
        CPI  0EH
        JNZ  GETDE
        POP  PSW
        RET
GETDE:
        INX  H
        MOV  E,M
        INX  H
        MOV  D,M
K94:
        MOV  A,M
        INX  H
        ORA  A
        JZ   ERRN08
        CPI  27H; [']
        JNZ  K94
        RET
K95:
        INR  C
        CALL ANAREG
        CPI  01H
        JZ   ERRN08
        PUSH H
        CALL GETMET
        JMP  K97
K96:
        INX  H
        PUSH H
        LHLD BFN
        XCHG
        LHLD AOR;  ORG
        DAD  D
        XCHG
K97:
        POP  H
        MVI  C,02H
        RET
ANACOD:
        LDA  CM4;   STAX
        CPI  58H;     'X'
        JNZ  K99
        STA  CM3;   LDAX=LDX, STAX=STX ?
K99:
        LDA  CMD;   1-   (ADD-pp)
        SUI  41H;   'A'=0, 'B'=1...
        JM   LESS40;  A

        MOV  E,A;    p   'A' = 0
        MVI  D,00H;   pp  1 

        LXI  H,TB2;   2 = 0F6A9H
        DAD  D;       p 
        MOV  E,M;       -  E
        INX  H;         .
        MOV  A,M;       -  A
        SUB  E;      A-E=A -  pp
;                     p 
        JZ  LESS40; A=E - JMP p = 0 =>
;                    pp 
        MOV  C,A;    C=A-E p (.-p.)
        PUSH B;     [BC]-p p

        LXI  H,TB3;   3 = 0F6C5H
        DAD  D;         3*E ->
        DAD  D;      p  
        DAD  D;      
;
        MVI  C,20H
        LDA  CM2;   CMD+1 (p  CMD)
        SUB  C;     CMD+1-20H
        JZ   K9A;   p  CMD = 20H

        SUB  C;     CMD+1-40H
        JM   LESS40; < 40H - p  

K9A:;___  DE 
        RLC; *2  -  p CMD+1-40H 
        RLC; *4
        RLC; *8
        MOV  B,A;  (CMD+1-40H)*8, D=4: 20H 0010.0000b

        LDA  CM3;   CMD+2 (p  CMD)
        SUB  C;     CMD+2-20H
        JZ   K9B;    CMD = 20H

        SUB  C;     CMD+2-40
        JM   LESS40; < 40H - p  
K9B:
        RRC; A/2 - p CMD+2-40H p
        RRC; A/4
        MOV  C,A;  (CMD+2-40H)/4, D=4: 01H 0000.0001b
        ANI  07H;  0000.0111b
        ORA  B;                   D=4: 21H
        MOV  D,A;  D = 21H
        MOV  A,C;  A = 01H
        ANI  0C0H; 1100.0000b
        MOV  E,A;   DE  = 2101H

        POP  B;    [BC]- p
LOOKDE:
        MOV  A,M;   3
        INX  H;    
        CMP  D;   p [D]
        JNZ  NEXTT3

        MOV  A,M; .  3
        ANI  0C0H;  2 . 1100.0000b
        CMP  E;    [C]
        JZ   K9F
NEXTT3:
        INX  H
        INX  H
        DCR  C; -1    
        JNZ  LOOKDE
LESS40:
        MVI  B,04H
        JMP  CODERR
K9F:;___ 2    3
        MOV  A,M; p 2-  p TB3
        ANI  3FH;  6 . - 0011.1111b
        STA  OFS; p   TB0   p
        INX  H
        MOV  A,M;   3- 
        STA  KOP;   p
        RET
;----------------------
DISPER:
        LDA  K17
        DCR  A
        RZ

        LDA  ERR
        ORA  A;    A = 0 ?
        JNZ  KA2

        LDA  BA2
        ORA  A;    A = 0 ?
        JNZ  KA1

        LDA  KEY
        ORA  A;    A = 0 ?
        RNZ
KA1:
        LDA  ERR
        ORA  A;    A = 0 ?
KA2:
        PUSH PSW
        CALL PSSCR
        POP  PSW
        CNZ  HEK;   

        MVI  C,2AH; '*'
        CNZ  SCR;

        LXI  D,SBF
        LDAX D
        CPI  3BH;   ';'
        LXI  B,K2D; 1120H
        JZ   KA3

        XRA  A;      0
        STA  ZNK

        PUSH D
        CALL KA5
        POP  D
KA3:
        XCHG
        CALL LOOP3; 3 x ' '
        CALL LNS
KA4:
        LDA  ZNK
        ORA  A
        RZ
        XRA  A
        CALL PSSCR
        CALL KA5
        JMP  KA4
KA5:
        LDA  OFS
        CPI  0CH;
        RZ
        CPI  0DH;
        RZ
        CPI  11H;
        JZ   KAA

        LHLD BFN

        PUSH PSW
        XCHG
        LHLD AOR
        DAD  D
        CALL HLHEXC
        XCHG
        POP  PSW

        CPI  10H
        JZ   DISPHL
        MVI  B,04H
KA6:
        LDA  FIN
        SUB  L
        JZ   KA7
        MOV  A,M
        INX  H
        CALL HEK
        CALL SCR
        DCR  B
        JNZ  KA6
        LDA  FIN
        SUB  L
        SHLD BFN
KA7:
        STA  ZNK
        MOV  A,B
        RLC
        ADD  B
        MOV  B,A
        RET

DISPHL:
        MVI  C,28H; '('
        CALL SCR
        MVI  C,20H; ' '
        CALL SCR
        LHLD NUM_REG
        CALL HLHEXC;   '[HL]'
        MVI  A,29H; ')'
        CALL SCA
        MVI  B,04H
        RET
HEK:
        PUSH PSW
        PUSH B
        CALL HEX
        POP  B
        POP  PSW
        RET
KAA:
        XCHG
        CALL TO_CMD
        CALL GETMET
        XCHG
        MVI  B,0CH
HLHEXC:
        MOV  A,H
        CALL HEK
        MOV  A,L
        CALL HEK
        JMP  SCR; C -> p.

TB0:;__0F663H____  p  
;________________  - TBFUNK
        DB   0BH; *
        DB   00H;  

        DB   08H; *
        DB   01H;  pp

        DB   2EH; *
        DB   01H;  pp

        DB   00H;
        DB   01H;  pp

        DB   16H; *
        DB   02H;  2 

        DB   0EH; *
        DB   01H;  pp

        DB   26H; *
        DB   02H;  2 

        DB   2BH; *
        DB   01H;  pp

        DB   31H; *
        DB   01H;  pp

        DB   37H; *
        DB   01H;  pp

        DB   1BH; *
        DB   01H;  pp

        DB   3DH; *
        DB   02H;  2 

        DB   0C1H;*
        DB   02H;  2 

        DB   0D8H;?
        DB   00H;  

        DB   82H; *
        DB   02H;  2 

        DB   82H; *
        DB   02H;  2 

        DB   4DH; *
        DB   02H;  2 

        DB   59H; *
        DB   02H;  2 

TB1:;__0F687H_____ p   xx+R
        DB   01H;-   pp
        DB   41H; 'A'
        DB   07H;= R

        DB   01H;-   pp
        DB   42H; 'B'
        DB   00H;= R

        DB   01H;-   pp
        DB   43H; 'C'
        DB   01H;= R

        DB   01H;-   pp
        DB   44H; 'D'
        DB   02H;= R

        DB   01H;-   pp
        DB   45H; 'E'
        DB   03H;= R

        DB   01H;-   pp
        DB   48H; 'H'
        DB   04H;= R

        DB   01H;-   pp
        DB   4CH; 'L'
        DB   05H;= R

        DB   01H;-   pp
        DB   4DH; 'M'
        DB   06H;= R

        DB   02H;-   pp
        DB   53H; 'S'
        DB   50H; 'P'
        DB   08H;

        DB   03H;-   pp
        DB   50H; 'P'
        DB   53H; 'S'
        DB   57H; 'W'
        DB   09H;

        DB   00H;  STOP_BYTE

TB2:;__0F6A9H____ 1    
;____________________   p D 
;____________________  (-p.):
        DB   00H; 1 A: D = 6 pp  A
        DB   06H; 2 B: D = 0 pp  B
        DB   06H; 3 C: D =13 pp  C
        DB   13H; 4 D
        DB   1BH; 5 E: D = 3 pp  E !!!
        DB   1EH; 6 F
        DB   1EH; 7 G
        DB   1EH; 8 H
        DB   1FH; 9 I
        DB   22H;10 J  D =10 pp  J
        DB   2CH; 1 K
        DB   2CH; 2 L
        DB   30H; 3 M
        DB   32H; 4 N
        DB   33H; 5 O: D = 4 pp  O-ORG!!!
        DB   37H; 6 P
        DB   3AH; 7 Q
        DB   3AH; 8 R
        DB   48H; 9 S
        DB   51H;20 T: D = 0 pp  T
        DB   51H; 1 U: D = 0 pp  U
        DB   51H; 2 V: D = 0 pp  V
        DB   51H; 3 W: D = 0 pp  W
        DB   51H; 4 X: D = 4 pp  X
        DB   55H; 5 Y: D = 0 pp  Y
        DB   55H; 6 Z: D = 0 pp  Z
        DB   55H; 7 - p  Z

TB3:;__0F6C5H_____   
;                    p p
;             OFFSET    COD
        DB   1AH, 44H, 0CEH; 1  ACI N0
        DB   20H, 0C1H, 88H; 2  ADC r  = 88+R
        DB   21H, 01H,  80H; 3  ADD R  = 80+R
        DB   22H, 44H, 0C6H; 4  ADI N0
        DB   70H, 41H, 0A0H; 5  ANA r  = A0+R
        DB   72H, 44H, 0E6H; 6  ANI N0

        DB   0BH, 06H, 0CDH; 7  CALL
        DB   18H, 06H, 0DCH; 8  CC
        DB   68H, 06H, 0FCH; 9  CM
        DB   68H, 40H, 2FH; 10  CMA
        DB   68H, 0C0H, 3FH; 1  CMC
        DB   6CH, 01H, 0B8H; 2  CMP r  = B8+R
        DB   70H, 0C6H, 0D4H;3  CNC
        DB   76H, 86H, 0C4H; 4  CNZ
        DB   80H, 06H, 0F4H; 5  CP
        DB   81H, 46H, 0ECH; 6  CPE
        DB   82H, 44H, 0FEH; 7  CPI N0
        DB   83H, 0C6H, 0E4H;8  CPO
        DB  0D0H, 06H, 0CCH; 9  CZ

        DB   08H, 40H, 27H; 20  DAA
        DB   09H, 07H, 09H;  1  DAD r  = 09+8R
        DB   1CH, 82H, 05H;  2  DCR r  = 05+8R
        DB   1EH, 07H, 0BH;  3  DCX r  = 0B+8R
        DB   48H, 00H, 0F3H; 4  DI
        DB   10H, 0EH, 00H;  5  DB
        DB   0B8H, 0FH, 00H; 6  DW
        DB   98H, 10H, 00H;  7  DS N

        DB   48H, 00H, 0FBH; 8  EI
        DB   71H, 0DH, 00H;  9  END
        DB   8DH, 51H, 00H; 30  EQU

        DB   65H, 00H, 76H;  1  HLT

        DB   70H, 04H, 0DBH; 2  IN N0
        DB   74H, 82H, 04H;  3  INR r = 04+8R
        DB   76H, 07H, 03H;  4  INX r = 03+8R

        DB   18H, 06H, 0DAH; 5  JC
        DB   68H, 06H, 0FAH; 6  JM
        DB   6CH, 06H, 0C3H; 7  JMP
        DB   00H, 06H, 0C3H; 8  ------???
        DB   70H, 0C6H, 0D2H;9  JNC
        DB   76H, 86H, 0C2H;40  JNZ
        DB   80H, 06H, 0F2H; 1  JP
        DB   81H, 46H, 0EAH; 2  JPE
        DB   83H, 0C6H, 0E2H;3  JPO
        DB  0D0H, 06H, 0CAH; 4  JZ

        DB   20H, 46H, 3AH;  5  LDA N0 N1
        DB   26H, 09H, 0AH;  6  LDAX r = 0A+8R
        DB   43H, 06H, 2AH;  7  LHLD N0 N1
        DB  0C2H, 4AH, 01H;  8  LXI r,N0 N1 = 01+8R

        DB  0B2H, 45H, 06H;  9  MVI r,N0
        DB   7DH, 83H, 40H; 50  MOV r1,r2 = 40+8R1+R2

        DB   7CH, 00H, 00H;  1  NOP

        DB   90H, 41H, 0B0H; 2  ORA r = B0+R
        DB   92H, 44H, 0F6H; 3  ORI N0
        DB  0ADH, 04H, 0D3H; 4  OUT N0
        DB   91H, 0CCH, 00H; 5  ORG !!!

        DB   1AH, 00H, 0E9H; 6  PCHL
        DB   7CH, 08H, 0C1H; 7  POP r  = C1+8R
        DB  0ACH, 0C8H, 0C5H;8  PUSH r = C5+8R

        DB   0BH, 00H, 17H;  9  RAL
        DB   0CH, 80H, 1FH; 60  RAR
        DB   60H, 0C0H, 07H; 1  RLC
        DB   90H, 0C0H, 0FH; 2  RRC
        DB   2DH, 00H, 0C9H; 3  RET
        DB   18H, 00H, 0D8H; 4  RC
        DB   70H, 0C0H, 0D0H;5  RNC
        DB  0D0H, 00H, 0C8H; 6  RZ
        DB   76H, 80H, 0C0H; 7  RNZ
        DB   80H, 00H, 0F0H; 8  RP
        DB   68H, 00H, 0F8H; 9  RM
        DB   81H, 40H, 0E8H;70  RM
        DB   83H, 0C0H, 0E0H;1  RPO
        DB   9DH, 0BH, 0C7H; 2  RST n = C7+8n

        DB   10H, 81H, 98H;  3  SBB r = 98+R
        DB   12H, 44H, 0DEH; 4  SBI N0
        DB   43H, 06H, 22H;  5  SHLD N0 N1
        DB   82H, 00H, 0F9H; 6  SPHL
        DB  0A0H, 46H, 32H;  7  STA N0 N1
        DB  0A6H, 09H, 02H;  8  STAX r = 02+8R
        DB  0A0H, 0C0H, 37H; 9  STC
        DB  0A8H, 81H, 90H; 80  SUB r = 90+R
        DB  0AAH, 44H, 0D6H; 1  SUI N0

        DB   1AH, 00H, 0EBH; 2  XCHG
        DB   90H, 41H, 0A8H; 3  XRA r = A8+R
        DB   92H, 44H, 0EEH; 4  XRI N0
        DB   0A2H, 00H, 0E3H;5  XTHL
;-------------------------- 85 -  pp
ERS:DB   ':',00H
ASS:DB   8BH,90H,' ASSM_MX/4K: '
    DB   'F1-LIST '
LIN:DB   'F2-LINK '
    DB   'F3-'
EXE:DB   'EXE',8CH,19H,0AH,' ',0FH,00H
OZY:DB   '  ',00H

BEG:EQU  0000H; p p 

MAX:EQU  1001H;  p 

BHL:EQU  1050H
NER:EQU  1052H
K17:EQU  1053H
ERR:EQU  1054H
;--(01*) -   ?,
;--(02*) -    m?,
;--(03*) -    k?,
;--(04*) -    ?.

FIN:EQU  1055H
BFN:EQU  1057H

OFS:EQU  1059H
NUM_REG:EQU  105AH;   p (p, ORG)
NUM8REG:EQU  105BH
KOP:EQU  105CH
;----------------------------------
K1F:EQU  105DH
BBF:EQU  105FH;  p  pp
;----------------------------------
ZNK:EQU  1061H
KEY:EQU  1062H
SOR:EQU  1063H; p SET ORG
AOR:EQU  1064H;  ORG
SBF:EQU  1066H; p p 128 

CMD:EQU  10E6H; 1  
CM2:EQU  10E7H; 2
CM3:EQU  10E8H; 3
CM4:EQU  10E9H; 4

ELN:EQU  10F0H; 5
BA2:EQU  10F2H; 6

BUF:EQU  1100H; p  pp

K2D:EQU  1120H
;___ BIOS__
KBD:EQU  0C803H
SCR:EQU  0C809H
SCA:EQU  0C80FH
HEX:EQU  0C815H
LNS:EQU  0C818H
KLA:EQU  0C81BH
HIM:EQU  0C830H
FIL:EQU  0F824H
SAV:EQU  0F827H
EXT:EQU  0F82DH

STK:EQU  0D2FFH
EDT:EQU  0E806H

ZAK:EQU  0FFFCH
;ROM:EQU  0FFFEH
        END

; BCDEHLMA BDH SP PSW                                 ;
;-----------------------------------------------------;
; ACI ADC ADD ADI ANA ANI                             ; 6
; B -                                              ; 0
; CALL CC CM CMA CMC CMP CNC CNZ CP CPE CPI CPO CZ    ;13=0DH
; DAA DAD DCR DCX DI                                  ; 5
; EI                                                  ; 1
; F -                                              ; 0
; G -                                              ; 0
; HLT                                                 ; 1
; IN INR INX                                          ; 3
; JC JM JMP JNC JNZ JP JPE JPO JZ                     ; 9
; K -                                              ; 0
; LDA LDAX LHLD LXI                                   ; 4
; MOV MVI                                             ; 2
; NOP                                                 ; 1
; ORA ORI OUT                                         ; 3
; PCHL POP PUSH                                       ; 3
; Q -                                              ; 0
; RAL RAR RC RET RLC RM RNC RNZ RP RPE RPO RRC RST RZ ;14=0EH
; SBB SBI SHLD SPHL STA STAX STC SUB SUI              ; 9
; T -                                              ; 0
; U -                                              ; 0
; V -                                              ; 0
; W -                                              ; 0
; XCHG XRA XRI XTHL                                   ; 4
; Y -                                              ; 0
; Z -                                              ; 0
;-----------------------------------------------------;